/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Heatmap.xs. Do not edit this file, edit Heatmap.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Heatmap.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "ppport.h"
#include <math.h>   /* exp(3), sqrt(3), ceil(3) */

/* From Module::Install::XSUtil. Thanks to gfx. */
#ifndef STATIC_INLINE /* from 5.13.4 */
# if defined(__GNUC__) || defined(__cplusplus) || (defined(__STDC_VERSION__) && (__STDC_VERSION__ >= 199901L))
#   define STATIC_INLINE static inline
# else
#   define STATIC_INLINE static
# endif
#endif /* STATIC_INLINE */


/* Ignore calculating pixel value if its value is less than this. */
const double EXP_IGNORE_THRESHOLD = -36.04365338911715; /* log(DBL_EPSILON) */

typedef unsigned int uint;

STATIC_INLINE SV*
valid_av_fetch(AV *array, int index)
{
    SV **item = av_fetch(array, index, 1);
    if (item == NULL) {
        croak("Fetched data from array was unexpectedly NULL");
    }

    return *item;
}

static int
fetch_pdata(AV *insert_datas, int *px, int *py, double *pweight)
{
    SV *pdata = av_shift(insert_datas);

    if (!SvOK(pdata)) return 0; /* End of data */

    if (!SvROK(pdata) || SvTYPE(SvRV(pdata)) != SVt_PVAV)
        goto invdata;

    I32 datalen = av_len((AV *)SvRV(pdata)) + 1;
    if (datalen < 2)
        goto invdata;

    AV *pdata_av = (AV *)SvRV(pdata);
    *px      = SvIV(valid_av_fetch(pdata_av, 0));
    *py      = SvIV(valid_av_fetch(pdata_av, 1));
    *pweight = (datalen > 2) ? SvNV(valid_av_fetch(pdata_av, 2)) : 1;

    return 1;

invdata:
    croak("insert_data should be an array reference "
          "which contains x, y, and optionally weight");
}

STATIC_INLINE max(int a, int b) { return (a > b) ? a : b; }
STATIC_INLINE min(int a, int b) { return (a < b) ? a : b; }

/* Calculate the probability density of each point insertion
 * for each pixels around it which to be get affected of insertion. */
static void
calc_probability_density(AV *matrix, AV *insert_datas,
                         uint xsize, uint ysize,
                         double xsigma, double ysigma, double correlation)
{
    const int w = xsize, h = ysize;

    /* Calculate things to not calculate these again. */
    const double xsig_sq   = xsigma * xsigma;
    const double ysig_sq   = ysigma * ysigma;
    const double xysig_mul = xsigma * ysigma;
    const double alpha     = 2 * correlation;
    const double beta      = 2 * (1 - correlation * correlation);

    /* (X|Y)-direction effective range of point insertion. */
    const uint x_affect_range = (uint)ceil(sqrt(-(EXP_IGNORE_THRESHOLD * beta) * xsig_sq));
    const uint y_affect_range = (uint)ceil(sqrt(-(EXP_IGNORE_THRESHOLD * beta) * ysig_sq));

    /*
     * The equation used to calculate 2-dimensional probability density
     * can be found at following URL:
     * Multivariate normal distribution - Wikipedia, the free encyclopedia
     *    http://en.wikipedia.org/wiki/Multivariate_normal_distribution#Bivariate_case
     */
    int    px, py;
    double pweight;
    while (fetch_pdata(insert_datas, &px, &py, &pweight)) {
        int x_beg = max(0, px - x_affect_range);
        int x_end = min(w, px + x_affect_range);
        int y_beg = max(0, py - y_affect_range);
        int y_end = min(h, py + y_affect_range);

        int x, y;
        for (x = x_beg; x < x_end; x++) {
            for (y = y_beg; y < y_end; y++) {
                int xd = x - px;
                int yd = y - py;

                SV *pixel_valsv = valid_av_fetch(matrix, x+w*y);

                double pixel_val = 0.0;
                if (SvOK(pixel_valsv)) {
                    pixel_val = SvNV(pixel_valsv);
                }

                pixel_val += exp(
                    -(xd*xd/xsig_sq + yd*yd/ysig_sq - alpha*xd*yd/xysig_mul) / beta
                ) * pweight;

                sv_setnv(pixel_valsv, pixel_val);
            }
        }
    }
}

#line 129 "Heatmap.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 273 "Heatmap.c"

XS_EUPXS(XS_Imager__Heatmap_xs_build_matrix); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Imager__Heatmap_xs_build_matrix)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "matrix, insert_datas, xsize, ysize, xsigma, ysigma, correlation");
    {
	AV *	matrix;
	AV *	insert_datas;
	unsigned int	xsize = (unsigned int)SvUV(ST(2))
;
	unsigned int	ysize = (unsigned int)SvUV(ST(3))
;
	double	xsigma = (double)SvNV(ST(4))
;
	double	ysigma = (double)SvNV(ST(5))
;
	double	correlation = (double)SvNV(ST(6))
;
	AV *	RETVAL;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    matrix = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Imager::Heatmap::xs_build_matrix",
				"matrix");
		}
	} STMT_END
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    insert_datas = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Imager::Heatmap::xs_build_matrix",
				"insert_datas");
		}
	} STMT_END
;
#line 134 "Heatmap.xs"
        calc_probability_density(
            matrix, insert_datas,
            xsize, ysize,
            xsigma, ysigma, correlation
        );

        RETVAL = matrix;
#line 331 "Heatmap.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Imager__Heatmap); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Imager__Heatmap)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Imager::Heatmap::xs_build_matrix", XS_Imager__Heatmap_xs_build_matrix);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
